
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <assert.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <stdlib.h>

#include <zend_extensions.h>
#include <zend_variables.h>
#include <zend_hash.h>
#include <php.h>
#include <php_ini.h>
#include <php_globals.h>
#include <SAPI.h>

#include "onstatement.h"

#ifdef ZTS
int onstatement_globals_id;
#else
php_onstatement_globals onstatement_globals;
#endif

//	============ A dirty global variable to turn debugging on and off.
static int	__iOnStatement=0;
static int	__iOnStatementDepth=0;

char * pzOnStatementCommandVarname 	= "OnStatementCommand" ;
char * pzOnStatementLineNum 		= "OnStatementLinenum" ;
char * pzOnStatementFileName 		= "OnStatementFileName" ;
char * pzOnStatementDepth    		= "OnStatementDepth" ;
char * pzOnFunctionBegin    		= "OnFunctionBegin" ;
char * pzOnFunctionEnd      		= "OnFunctionEnd" ;
char * pzOnFunctionName     		= "OnFunctionName" ;
char * pzOnDeactivateCommandVarname	= "OnDeactivateCommand" ;

// It would be better the read this from the INI files ... 
// but I'll do it later ...

#define ONS_COMMAND	pzOnStatementCommandVarname
#define ONS_LINENO	pzOnStatementLineNum
#define ONS_FILENAME	pzOnStatementFileName 
#define ONS_DEPTH  	pzOnStatementDepth    
#define ONS_FBEGIN	pzOnFunctionBegin      
#define ONS_FEND	pzOnFunctionEnd      
#define ONS_FNAME	pzOnFunctionName
#define ONS_DEACTIVATE	pzOnDeactivateCommandVarname       

//	Create and export a zend_extension_version_info
// #define ZEND_EXT_API
ZEND_EXTENSION();

//  Create and export a zend_extension
ZEND_EXT_API 	zend_extension	zend_extension_entry_booze = {
	"Bike Odyssey OnStatement Zend Extension (BOOZE)",
	"1.16.1",
	"djf01@ozemail.com.au",
	"http://www.ozemail.com.au/~djf01",
	"Bike Odyssey Pty Ltd",

	NULL,
	NULL,
	onActivate,
	onDeactivate,
	NULL,
	NULL,
	onStatement,
	onFCallBegin,
	onFCallEnd,
	NULL,
	NULL,

	STANDARD_ZEND_EXTENSION_PROPERTIES
};

ZEND_EXT_API	void	onActivate()
{
	CLS_FETCH();
	SLS_FETCH();

	CG( extended_info ) = 1;
	__iOnStatement = 0;
// printf("\nOnActivate() Called !!!!");
}

ZEND_EXT_API 	void	onDeactivate()
{
	__iOnStatement = 0;
}


ZEND_EXT_API 	void	onStatement( zend_op_array *op_array )
{
	zval	val, val_tmp, val_depth;
	char  	szCommand[1024];
	char 	*pFilename, *pFunctionname;
	int  	iLineno;

//	printf("<br>Made it to OnStatement\n");
	if( __iOnStatement )
	{
		ELS_FETCH();
		CLS_FETCH();
		SLS_FETCH();

//	Lets get the global varible OnStatementDepth

		sprintf(szCommand,
			"($GLOBALS[\"%s\"] > 0)",
			ONS_DEPTH   );

		val.type = 0xFF ;
		ZEND_EVAL_STRING(szCommand, &val );
		if( Z_LVAL(val) && val.type == IS_BOOL)
			return ;

//	Lets get the value of the global variable OnStatementCommand

		sprintf(szCommand,
			"$GLOBALS[\"%s\"]",
			ONS_COMMAND );

		val.type = 0xFF ;

		ZEND_EVAL_STRING(szCommand, &val );

		//	Now, we need to check the command exists.
		if( val.type == IS_STRING )
		{
			if( strlen(Z_STRVAL(val)) > 0 )
			{
				//	OK, so we really have a command to run ...
				pFilename = zend_get_executed_filename();
				if( pFilename )
				{
					
					sprintf(szCommand,
						"$GLOBALS[\"%s\"]=\"%s\"",
						ONS_FILENAME,
						pFilename );

					ZEND_EVAL_STRING(szCommand, &val_tmp );
				} 

				iLineno = zend_get_executed_lineno();
				if( iLineno )
				{
					sprintf(szCommand,
						"$GLOBALS[\"%s\"]=\"%u\"",
						ONS_LINENO,
						iLineno );

					ZEND_EVAL_STRING(szCommand, &val_tmp );
				}

				pFunctionname = get_active_function_name();
				if( pFunctionname )
				{
					if( *pFunctionname )
					{
						sprintf(szCommand,
							"$GLOBALS[\"%s\"]=\"%s\"",
							ONS_FNAME,
							pFunctionname );

						ZEND_EVAL_STRING(szCommand, &val_tmp );
 					}
				}

				sprintf(szCommand,
					"$GLOBALS[\"%s\"]=1+$GLOBALS[\"%s\"]",
					ONS_DEPTH, ONS_DEPTH );
				ZEND_EVAL_STRING(szCommand, &val_tmp ); 
				sprintf(szCommand,
					"eval($GLOBALS[\"%s\"])",
					ONS_COMMAND );
				ZEND_EVAL_STRING(szCommand, &val_tmp );
				sprintf(szCommand,
					"$GLOBALS[\"%s\"]--",
					ONS_DEPTH );
				ZEND_EVAL_STRING(szCommand, &val_tmp ); 
			}
		}
	}
}

ZEND_EXT_API	void	onFCallBegin( zend_op_array* op_array )
{
	zval	val, val_tmp;

	char  szCommand[1024];

	if( __iOnStatement )
	{
		ELS_FETCH();
		CLS_FETCH();

//	Lets get the value of the global variable OnStatementCommand

//		sprintf(szCommand,
//			"$GLOBALS[\"%s\"]=\"%s\"",
//			ONS_FNAME,
//			get_active_function_name() );
//
//		ZEND_EVAL_STRING(szCommand, &val_tmp ); 
//	Lets get the global varible OnStatementDepth

		sprintf(szCommand,
			"($GLOBALS[\"%s\"] > 0)",
			ONS_DEPTH   );

		val.type = 0xFF ;
		ZEND_EVAL_STRING(szCommand, &val );
		if( Z_LVAL(val) && val.type == IS_BOOL)
			return ;

		sprintf(szCommand,
			"$GLOBALS[\"%s\"]",
			ONS_FBEGIN );

		val.type = 0xFF ;

		ZEND_EVAL_STRING(szCommand, &val );

		//	Now, we need to check the command exists.
		if( val.type == IS_STRING )
		{
			if( strlen(Z_STRVAL(val)) > 0 )
			{
				sprintf(szCommand,
					"eval($GLOBALS[\"%s\"])",
					ONS_FBEGIN);
				ZEND_EVAL_STRING(szCommand, &val_tmp );
			}
		}
	}
}

ZEND_EXT_API	void	onFCallEnd( zend_op_array* op_array )
{
	zval	val, val_tmp;

	char  szCommand[1024];

	if( __iOnStatement )
	{
		ELS_FETCH();
		CLS_FETCH();

//	Lets get the global varible OnStatementDepth

		sprintf(szCommand,
			"($GLOBALS[\"%s\"] > 0)",
			ONS_DEPTH   );

		val.type = 0xFF ;
		ZEND_EVAL_STRING(szCommand, &val );
		if( Z_LVAL(val) && val.type == IS_BOOL)
			return ;

		sprintf(szCommand,
			"$GLOBALS[\"%s\"]",
			ONS_FEND );

		val.type = 0xFF ;

		ZEND_EVAL_STRING(szCommand, &val );

		//	Now, we need to check the command exists.
		if( val.type == IS_STRING )
		{
			if( strlen(Z_STRVAL(val)) > 0 )
			{
				sprintf(szCommand,
					"eval($GLOBALS[\"%s\"])",
					ONS_FEND ) ;

				ZEND_EVAL_STRING(szCommand, &val_tmp ); 
			}
		}
	}
}

//	Functions to Activate and De-Activate the OnStatement Function

/* declaration of functions to be exported */
	ZEND_FUNCTION(onstatement_activate);
	ZEND_FUNCTION(onstatement_deactivate);
	ZEND_FUNCTION(confirm_onstatement_compiled);
	ZEND_FUNCTION(_fl);
	ZEND_FUNCTION(_ln);
	ZEND_FUNCTION(_fn);
	ZEND_FUNCTION(mkfifo);

/* compiled function list so Zend knows what's in this module */
zend_function_entry onstatement_functions[] =
{
	ZEND_FE(confirm_onstatement_compiled,	NULL)		
	ZEND_FE(onstatement_activate, NULL)
	ZEND_FE(onstatement_deactivate, NULL)
	ZEND_FE(_fl, NULL)
	ZEND_FE(_fn, NULL)
	ZEND_FE(_ln, NULL)
	ZEND_FE(mkfifo, NULL)
	{NULL, NULL, NULL}
};

/* compiled module information */
zend_module_entry onstatement_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
	STANDARD_MODULE_HEADER,
#endif
	"onstatement",
	onstatement_functions,
	PHP_MINIT(onstatement),
	PHP_MSHUTDOWN(onstatement),
	PHP_RINIT(onstatement),		/* Replace with NULL if there's nothing to do at request start */
	PHP_RSHUTDOWN(onstatement),	/* Replace with NULL if there's nothing to do at request end */
	PHP_MINFO(onstatement),
#if ZEND_MODULE_API_NO >= 20010901
	"1.16.1",
#endif
	STANDARD_MODULE_PROPERTIES
};

/* implement standard "stub" routine to introduce ourselves to Zend */
#if COMPILE_DL_ONSTATEMENT
ZEND_GET_MODULE(onstatement)
#endif

PHP_MINIT_FUNCTION(onstatement)
{
/* Remove comments if you have entries in php.ini
	REGISTER_INI_ENTRIES();
*/
	zend_register_extension(&zend_extension_entry_booze, (DL_HANDLE) 0);
	return SUCCESS;
}

PHP_MSHUTDOWN_FUNCTION(onstatement)
{
/* Remove comments if you have entries in php.ini
	UNREGISTER_INI_ENTRIES();
*/
	return SUCCESS;
}

/* Remove if there's nothing to do at request start */
PHP_RINIT_FUNCTION(onstatement)
{
	return SUCCESS;
}

/* Remove if there's nothing to do at request end */
PHP_RSHUTDOWN_FUNCTION(onstatement)
{
	return SUCCESS;
}

PHP_MINFO_FUNCTION(onstatement)
{
	php_info_print_table_start();
	php_info_print_table_header(2, "onstatement support", "enabled");
	php_info_print_table_end();

	/* Remove comments if you have entries in php.ini
	DISPLAY_INI_ENTRIES();
	*/
}


/* Implement function to activate the debugger */
ZEND_FUNCTION(onstatement_activate)
{
	CLS_FETCH();
	SLS_FETCH();

// printf("\nMade it to onstatement_activate()<br>\n");
//	CG( extended_info ) = 1;

	__iOnStatement = 1;
	RETURN_NULL();
}

/* Implement function to deactivate the debugger */
ZEND_FUNCTION(onstatement_deactivate)
{
	CLS_FETCH();
	SLS_FETCH();

//	CG( extended_info ) = 0;

	__iOnStatement = 0;
	RETURN_NULL();
}

ZEND_FUNCTION(_fl)
{
	char * p;
	zval	val;
	char szCommand[1024];

	CLS_FETCH();
	ELS_FETCH();
	SLS_FETCH();

	if( __iOnStatement )
	{
		sprintf( szCommand,
			"$GLOBALS[\"%s\"]",
			ONS_FILENAME );
	
		ZEND_EVAL_STRING(szCommand, return_value );
	}
	else
	{
		p = zend_get_executed_filename();
		if( !p )
			p = "(Null)";
		RETVAL_STRING( p , 1 );
	}
}

ZEND_FUNCTION(_ln)
{
	char * p;
	zval	val;
	char szCommand[1024];
	int  iLineNo;

	CLS_FETCH();
	ELS_FETCH();
	SLS_FETCH();

	if( __iOnStatement )
	{
		sprintf( szCommand,
			"$GLOBALS[\"%s\"]",
			ONS_LINENO  );
	
		ZEND_EVAL_STRING(szCommand, return_value );
	}
	else
	{
		iLineNo = zend_get_executed_lineno();
		RETVAL_LONG( iLineNo );
	}
}

ZEND_FUNCTION(_fn)
{
	zval	val;
	char szCommand[1024];

	CLS_FETCH();
	ELS_FETCH();
	SLS_FETCH();

	sprintf( szCommand,
		"$GLOBALS[\"%s\"]",
		ONS_FNAME   );
	
	ZEND_EVAL_STRING(szCommand, return_value );
}

ZEND_FUNCTION(mkfifo)
{
	zval **arg;
	int len;
	char szFilename[1024];
	char szBuffer[2048];
	char string[256];
	int iResult;
	mode_t   mMode ;

	if (ZEND_NUM_ARGS() != 1 || zend_get_parameters_ex(1, &arg) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	strcpy(szFilename, Z_STRVAL_PP(arg));
	
	mMode = umask(0);
	iResult = mkfifo(szFilename, S_IROTH | S_IWOTH | S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP);
	if( iResult )
	{
		sprintf(szBuffer, "Unable to open %s because %s",
			szFilename, strerror(errno));
		zend_error(E_WARNING, szBuffer);
		umask(mMode);
		RETURN_TRUE;
	}
	umask(mMode);
	RETURN_FALSE;    	
}


ZEND_FUNCTION(confirm_onstatement_compiled)
{
	zval **arg;
	int len;
	char string[256];

	if (ZEND_NUM_ARGS() != 1 || zend_get_parameters_ex(1, &arg) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(arg);

	len = sprintf(string, "Congratulations, you have successfully modified ext/onstatement/config.m4, module %s is compiled into PHP", Z_STRVAL_PP(arg));
	RETVAL_STRINGL(string, len, 1);
}


